#include <amxmodx>
#include <cstrike>
#include <hamsandwich>
#include <fakemeta>

new const iPlugin[][] = 
{
	"Totemic", // Название плагина
	"1.2", // Версия
	"Light" // Автор
};

new const iPARAM[][] = 
{
	"say /totem", // Команда открытия меню покупки
	"Тотем Бессмертия", // Название Тотема
	"500", // Стоимость
	"80", // Сколько прибавиться хп
	"1", // Сколько тотемов будет даваться за покупку
	"5" // Сколько должно быть ХП что бы активировать тотем
};

new const TotemRGB[] = {201,77,0} // red, green, blue | красный, зелёный, синий | max 255 , min 0

new gPlayerTotemic[33];

public plugin_init()
{
	register_plugin(iPlugin[0], iPlugin[1], iPlugin[2])
	register_clcmd(iPARAM[0], "menu_buy")
	RegisterHam(Ham_TakeDamage, "player", "PreDamagePlayer", false)
}

public client_connect(id)
{
	gPlayerTotemic[id] = 0;
}

public client_disconnected(id)
{
	gPlayerTotemic[id] = 0;
}

public menu_buy(id)
{
	new iMenu = menu_create(fmt("%s [by light] - %s$", iPARAM[1], iPARAM[2]), "menu_handler")

	menu_additem(iMenu, "Купить", "1")

	menu_display(id, iMenu, 0)
}

public menu_handler(id, menu, item)
{
	if (item == MENU_EXIT)
	{
		menu_destroy(menu)
		return PLUGIN_HANDLED;
	}

	new s_Data[6], s_Name[64], i_Access, i_Callback
	menu_item_getinfo(menu, item, i_Access, s_Data, charsmax(s_Data), s_Name, charsmax(s_Name), i_Callback)
	menu_destroy(menu)
	if(str_to_num(s_Data) == 1) TrueCommand(id)
	return PLUGIN_HANDLED;
}

public TrueCommand(id)
{
	if(cs_get_user_money(id) < str_to_num(iPARAM[2]))
	{
		client_print(id, print_center, "Недостаточно средств!")
		return PLUGIN_HANDLED;
	}

	cs_set_user_money(id, cs_get_user_money(id) - str_to_num(iPARAM[2]))
	gPlayerTotemic[id] += str_to_num(iPARAM[4]);
	client_print(id, print_center, "Вы купили тотем!")

	return PLUGIN_HANDLED;
}

public PreDamagePlayer(victim, weapon, attacker, Float:damage, damage_type)
{
	if(is_user_connected(victim) && gPlayerTotemic[victim] > 0 && pev(victim, pev_health) - damage <= str_to_num(iPARAM[4]))
	{
		set_pev(victim, pev_health, float(str_to_num(iPARAM[3])))
		gPlayerTotemic[victim]--;
		client_print(victim, print_center, "_light_: %s в действии! (Осталось: %d)", iPARAM[1], gPlayerTotemic[victim])
		message_begin(MSG_ONE, get_user_msgid("ScreenFade"), {0,0,0}, victim)
		write_short(1<<10)
		write_short(1<<10)
		write_short(0x0000)
		write_byte(TotemRGB[0]) // r
		write_byte(TotemRGB[1]) // g
		write_byte(TotemRGB[2]) // b
		write_byte(75)
		message_end()
		return HAM_SUPERCEDE;
	}

	return HAM_IGNORED;
}